<template>
  <div>
    <div class="container-fluid p-3 my-0" v-show="!isHidden" >
      <b-card style="box-shadow: 0 8px 12px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);">
        
        <div class="hrdivider">
          <hr/>
          <span>جستجو</span>
        </div>

        <b-form  @submit.prevent="searchItem">

          <b-row class="justify-content-md-center">

            <b-col  md="4">
              <b-form-group
              id="mySid"
              label="شناسه:"
              label-cols-sm="2"
              >
             <b-form-input
                      id="mySid2"
                      v-model="mySid"
                      
                  ></b-form-input>
              </b-form-group>   
            </b-col>

            <b-col  md="4">
              <b-form-group
              id="myShead"
              label="عنوان:"
              label-cols-sm="2"
              >
             <b-form-input
                      id="myShead2"
                      v-model="myShead"
                  ></b-form-input>
              </b-form-group>  
            </b-col>
            
          </b-row>
        
          <b-row class="justify-content-md-center"> 
            <b-button type="button" squared @click="searchItem"  style="background-color: #2A0A19;width:15%;margin-left:-655px;margin-top:10px;"> <fa class="" icon="search" style="margin-left:5px;"/> جستجو </b-button>
          </b-row>

        </b-form>

      </b-card>
    </div>

    <div class="container-fluid p-3 my-0" v-show="!isHidden">
      <b-card style="box-shadow: 0 8px 12px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);">
        
        <div class="hrdivider">
          <hr/>
          <span>لیست خبرها</span>
        </div>
        
        <div>

          <b-row>

            <b-col style="text-align:right;">
              <b-button @click="goInsert " type="button" class="btn" style="background-color: #2A0A19;margin-right:20px;" > <fa class="" icon="plus" /> اضافه کردن خبر </b-button>
            </b-col>

            <b-col cols="1" style="text-align:left;" >
              <b-form-select class="myselect" v-model="selected" :options="options" size="sm" ></b-form-select>
            </b-col>

          </b-row>

        </div>

        <b-table striped fixed small hover show-empty empty-text="هیچ خبری برای نمایش وجود ندارد!"
          id="my-table"
          :items="items"
          :fields="fields"
          :per-page="selected"
          :current-page="currentPage"
          style="margin-top:20px;text-align:center;">

          <template v-slot:cell(_id)="HoverId">
            <b-button size="sm" squared variant="outline-dark" v-b-tooltip.hover.left="HoverId.item._id" ><fa icon="copy"/></b-button>
          </template>

          <template v-slot:cell(desc)="HoverPrev">
            <b-button size="sm"  squared variant="outline-dark" @click="detailItem(HoverPrev.index,$event.target)"><fa icon="info"/></b-button>
          </template>

          <template v-slot:cell(isForce)="mych">
            <span v-if="mych.item.isForce" style="color:green;"><fa  icon="check" /></span>
            <span v-else style="color:red;"> <fa class="fa-lg" icon="times" color:red /></span>
          </template>

          <template v-slot:cell(isEdit)="myed">
            <b-button type="button" size="sm" @click="editItem(myed.index,$event.target);isHidden = !isHidden" squared variant="warning" ><fa  icon="edit" /></b-button>
          </template>

          <template v-slot:cell(isDelete)="myde">
            <b-button type="button" size="sm" @click="deleteItem(myde.index,$event.target);" squared variant="danger" ><fa  icon="trash-alt" /></b-button>
            
          </template>

        </b-table>
      
        <b-pagination class="myp"
          v-model="currentPage"
          :total-rows="rows"
          :per-page="selected"
          aria-controls="my-table"
          size="sm"
          align="center"
          color="#2A0A19"
          style="direction:ltr;"
        ></b-pagination>
       
      </b-card>
    </div>

    <div class="container-fluid p-3 my-0" v-show="isHidden && (myvalue2 == 'a')">
      <b-card style="box-shadow: 0 8px 12px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);">
       
       <div class="hrdivider">
          <hr/>
          <span>ویرایشگر شرح خبر</span>
        </div>

        <b-form-textarea
          rows="4"
          v-model="temp2.desc"
          >
        </b-form-textarea>

      </b-card>
    </div>

    <div class="container-fluid p-3 my-0" v-show="isHidden && (myvalue2 == 'b')">
      <b-card style="box-shadow: 0 8px 12px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);">
        
        <div class="hrdivider">
          <hr/>
          <span>ویرایشگر شرح خبر</span>
        </div>
          <client-only>
          <tinymce id="d2"
          v-model="temp2.desc"
          toolbar1 = "formatselect | bold italic strikethrough forecolor backcolor | link | alignleft aligncenter alignright alignjustify | numlist bullist | removeformat"
          ></tinymce>
          </client-only>

      </b-card>
    </div>
    
    <div class="container-fluid p-3 my-0" v-show="isHidden">
      <b-card style="box-shadow: 0 8px 12px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);">
        
        <div class="hrdivider">
          <hr/>
          <span >ویرایش خبر</span>          
        </div>

        <b-form  @submit.prevent="makeItem">
          <b-row class="justify-content-md-center">

            <b-col md="5">
              <b-form-group
                id="myH"
                label="عنوان خبر:"
                label-cols-sm="2"
                aria-describedby="input-live-feedback"
                >

                <b-form-input
                  id="myH2"
                  v-model="temp2.subject"
                  :state="temp2.subject ? true:false"
                ></b-form-input>

                <b-form-invalid-feedback id="input-live-feedback">
                عنوان خبر نمی تواند خالی باشد!
                </b-form-invalid-feedback>
             </b-form-group>    
            </b-col>

            <b-col md="5">
              <b-form-group
              id="pubDate"
              label="از تاریخ:"
              label-cols-sm="2"
              >
              <client-only>
              <date-picker id="pubDate" v-model="temp2.fromDate" type="datetime" format="YYYY/MM/DD HH:mm:ss" display-format="HH:mm jYYYY-jMM-jDD" :timezone="true" color="#2A0A19"></date-picker>
              </client-only>
              </b-form-group>  
            </b-col>
            
          </b-row>

          <b-row class="justify-content-md-center">

            <b-col md="5">
              <b-form-group
              id="myT"
              label="شرح خبر:"
              label-cols-sm="2"
              >

              <b-form-select 
                id="myT2"
                v-model="myvalue2"
                :options="optionsText"
              ></b-form-select>
              </b-form-group>
            </b-col>
            
            <b-col md="5">

              <b-row>

                <b-col>
                  <b-form-group
                  id="expDate"
                  label="تا تاریخ:"
                  label-cols-sm="2"
                  >
                  <client-only>
                  <date-picker id="expDate" v-model="temp2.toDate" type="datetime" format="YYYY/MM/DD HH:mm:ss" display-format="HH:mm jYYYY-jMM-jDD" :timezone="true" color="#2A0A19"></date-picker>
                  </client-only>
                  </b-form-group>  
                </b-col>

              </b-row>

              <b-row>

                <b-col>
                  <b-form-group
                  id="isForce"
                  label="ضروری:"
                  label-cols-sm="2"
                  >
                  <b-form-checkbox v-model="temp2.isForce" name="isForce" switch style="margin-top:7px;margin-right:-12px;"></b-form-checkbox>
                  </b-form-group>  
                </b-col>

              </b-row>

            </b-col>

          </b-row>
         
          <b-row class="justify-content-md-center" > 
            <b-button  type="submit" squared @click="makeItem;isHidden = !isHidden;myvalue2 = 'null'" style="background-color: #2A0A19;width:15%;margin-left:5px;margin-top:15px;font-weight:bold;" >ذخیره</b-button>
            <b-button  type="submit" squared @click="backItem;isHidden = !isHidden" variant="warning" style="width:15%;margin-top:15px;font-weight:bold;" >بازگشت</b-button>
          </b-row>

        </b-form>

      </b-card>
    </div>

  </div>
</template> 

<script>

  export default {  
    data() {
      return {

        currentPage: 1,
        selected: 5,

        mySid: '',
        myShead: '',

        myvalue2: 'null',

        isHidden: false,

        DeleteBox: '',
        detailBox: '',

        datetime: '',

        editIndex : 0,
        
        forGetAll:{
          pageNum: 0,
          count: 40
        },
        forDelete:{
          newsId:''
        },
        forEditItem:{
          newsId:''
        },
    
        optionsText: [
          { value: null, text: 'یک حالت را انتخاب کنید' },
          { value: 'a', text: 'ویرایشگر ساده' },
          { value: 'b', text: 'ویرایشگر پیشرفته' },
        ],
          
        fields: [
          { key: '_id', label: 'شناسه' },
          { key: 'subject', label: 'عنوان خبر' },
          { key: 'desc', label: 'جزئیات خبر' },
          { key: 'fromDate', label: 'از تاریخ',formatter: 'myFromDate' },
          { key: 'toDate', label: 'تا تاریخ' ,formatter: 'myToDate' },
          { key: 'isForce', label: 'ضروری' },
          { key: 'isEdit', label: 'ویرایش' },
          { key: 'isDelete', label: 'حذف' },

        ],
        options: [  
          { value: '5', text: '5' },
          { value: '10', text: '10' },
          { value: '20', text: '20' }
        ],

        items : [],

        temp2: {
          newsId: '',
          subject: '',
          desc: '',
          fromDate: '',
          toDate: '',
          isForce: false, 
        }
      }
      },
      async fetch ()
      { 
        this.items = []
        this.$axios.post('/news/getAll', this.forGetAll)
        .then(response => {
          for(const key in response.data.result.data){
            this.items.push(response.data.result.data[key])
          }
        })
        .catch(e =>{
          console.log(e)
        })
      },
      fetchOnServer: false,
  
    methods:
    {
      myFromDate(value) {
        var b = new Date(value).toLocaleDateString('fa-IR')
        var a = new Date(value).toLocaleTimeString('fa-IR')
        return a + ' ' + b
      },
      myToDate(value) {
        var b = new Date(value).toLocaleDateString('fa-IR')
        var a = new Date(value).toLocaleTimeString('fa-IR')
        return a + ' ' + b
      },
      
      makeItem()
      {
        this.$axios.post('/news/update', this.temp2)
        .then(response => 
        {
          this.items.push(this.temp2)
          this.items.splice(this.editIndex, 1);

        })
        .catch(e =>{
            console.log(e)
          })
          
      }, 

      backItem()
      {
        //this.temp2 = {}
      },

      goInsert()
      {
       this.$router.push('/news/insert')
      },

      deleteItem(index,button)
      {
        if (this.items[index]._id != undefined)
        {
          this.forDelete.newsId = this.items[index]._id}
        else
        {
          this.forDelete.newsId = this.temp2.newsId
        }

        this.DeleteBox = ''
        this.$bvModal.msgBoxConfirm(<b>آیا تایید می‌کنید که خبر پاک شود ؟</b>, {
          title: '',
          size: 'md',
          buttonSize: 'lg',
          okVariant: 'danger',
          cancelVariant: 'success',
          okTitle: 'بله!',
          cancelTitle: 'خیر',
          footerClass: 'p-2',
          hideHeaderClose: false,
          centered: true
        })
          .then(value => {
            this.DeleteBox = value
            
            if(this.DeleteBox)
            {
              this.$axios.post('/news/delete', this.forDelete)
              .then(response => {
                this.items.splice(index, 1);
              })
              .catch(e =>{
                console.log(e)
              })
            }
          })
          .catch(err => {
            // An error occurred
          })
        
      },
      searchItem(){
        console.log('Hi')
      },

      editItem(index,button)
      {
       
        if (this.items[index]._id == undefined)
        {
          this.temp2.newsId =  this.forEditItem}
        else{
          this.temp2.newsId = this.items[index]._id
          this.forEditItem = this.items[index]._id
        }

        this.temp2.subject = this.items[index].subject
        this.temp2.desc = this.items[index].desc

        this.datetime = this.items[index].fromDate
        this.temp2.fromDate = this.datetime

        this.datetime = this.items[index].toDate
        this.temp2.toDate = this.datetime
        
        this.temp2.isForce = this.items[index].isForce   
        this.editIndex = index
        
      },
      detailItem(index,button)
      {
        this.detailBox = ''

        const h = this.$createElement
        const titleVNode = h('div', { domProps: { innerHTML: this.items[index].desc } })

        this.$bvModal.msgBoxOk([titleVNode], {
          
          size: 'lg',
          buttonSize: 'md',
          okVariant: 'success',
          headerClass: 'p-2 border-bottom-0',
          footerClass: 'p-2 border-top-0',
          centered: true
        })
          .then(value => {
            this.detailBox = value
          })
          .catch(err => {
            // An error occurred
          })
      }

    },
    
    computed:
    {
      rows()
      {
        return this.items.length
      },
    },

  }
</script>

<style >

.hrdivider {
  position: relative;
  margin-bottom: 30px;
  width: 100%;
  text-align: right;
}
.hrdivider span {
  position: absolute;
  top: -20px;
  background: #fff;
  padding: 0 20px;
  font-size: 25px;
}
.pagination .page-item.active .page-link {  
    background-color: #2A0A19 !important;  
    border-color: gray !important;  
}
.myselect {
  color: #2A0A19; 
}

</style>